Prime Path
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
寻找从 素数n 到素数 m 每次只能变化一位数字的 最少变化次数,且每次变化得到的数字也为素数
题意:
寻找从素数 n 变换到 素数 m 的最少变换次数,每次只能变换一位数字,且每次变化得到的数字也为素数。
(素数)→(素数)
知识储备:
0x3f3f3f3f的十进制是1061109567,是10⁹ 级别的(和0x7fffffff一个数量级),而一般场合下的数据都是小于10⁹ 的,所以它可以作为无穷大使用而不致出现数据大于无穷大的情形。
素数判断方法
bool isPrime(int n)
{
if(n==0||n==1)
return false;
for(int i=2; i<=sqrt(n); i++)
{
if(n%i==0)
return false;
}
return true;
}
#include<iostream>
#include<stdio.h>
#include<string.h>
#include<queue>
#include<math.h>
using namespace std;
const int manx=10001;
int n,m;
int vis[manx];
int digit[4]={1000,100,10,1};
bool isPrime(int n)//判断素数
{
if(n==0||n==1)
return false;
for(int i=2; i<=sqrt(n); i++)
{
if(n%i==0)
return false;
}
return true;
}
bool can(int x)//判断是否符合条件
{
if(!isPrime(x)||vis[x]!=-1)return false;//不是质数或者被标记过
else return true;
}
void BFS(int x)//计算几步变换成m
{
memset(vis,-1,sizeof(vis));//初始化标记数组vis
queue<int> q;//定义队列q
q.push(x);//入队
vis[x]=0;//标记
while(!q.empty())//队列不为空,刚开始队列装的是n
{
int now=q.front();
int tx=now;//tx用来保存当前这个数
q.pop();
for(int i=3; i>=0; i--)
{
int nowdigit=now%10;//分别获取个、十、百、千位数
now=now/10;
if(i!=0)//不存在前导零,第一位数不是0,需要特殊判断
{
for(int j=0; j<10; j++)
{
if(j==nowdigit)
continue;
else
{
int newx=(tx-nowdigit*digit[i]+j*digit[i]);
if(can(newx))
{
vis[newx]=vis[tx]+1;
if(newx==m)return;
q.push(newx);
}
}
}
}
else
{
for(int j=1; j<10; j++)
{
if(j==nowdigit)
continue;
else
{
int newx=(tx-nowdigit*digit[i]+j*digit[i]);
if(can(newx))
{
vis[newx]=vis[tx]+1;
if(newx==m)return;
q.push(newx);
}
}
}
}
}
}
}
int main()
{
int t;
cin>>t;
while(t--)
{
scanf("%d %d",&n,&m);
BFS(n);
if(vis[m]==-1)cout<<"Impossible"<<endl;
else
cout<<vis[m]<<endl;
}
return 0;
}